#TouhouDanmakufu[Stage]
#ScriptVersion[3]
#ID["Main"]
#Title["Aiiko Boss"]
#Text["Aiiko and Murloc play togheter with some danmaku (They don't [r]know they are being watched)."]
#Player["./System/Murloc/Reimu/Reimu.txt"]
#Image["./System/img/Toki&Aiiko.png"]


#include "./System/ZUNShot_Const.txt"
#include"./Index.txt"
#include "./background.txt"
//#include "./script/system/lib/ReimuAnim.dnh"
#include "./System/dialogue.dnh"

	let end = false;
	let holding = false;
	let thinking = false;
let bgm = ObjSound_Create;
let bgm2 = ObjSound_Create;
let bgm3 = ObjSound_Create;
let bgm4 = ObjSound_Create;
let BGM = GetCurrentScriptDirectory() ~ "./SFX/Romantic Children.mp3";
let BGM2 = GetCurrentScriptDirectory() ~ "./SFX/Unknown X.mp3";
let BGM3 = GetCurrentScriptDirectory() ~ "./SFX/BGM_013.ogg";
let BGM4 = GetCurrentScriptDirectory() ~ "./SFX/Eternal Paradise.mp3";
let PlayerShotSE = GetCurrentScriptDirectory() ~ "/SFX/select.wav";
	let objEnemy;
	let Toki;
	let Timer =0;

@Event{/*
	alternative(GetEventType)
	case(EV_USER_STAGE) {
		let arg = GetEventArgument(0); // X and Y coordinates.
		CreateItemA1(ITEM_SPELL, arg[0], arg[1], 1500);
	}
	case(EV_USER_STAGE+1) {
		PlaySE(ExpSE3);
	}
	case(EV_USER_STAGE+2) {
		PlaySE(SpellGetSE);
	}
	case(EV_USER_STAGE+3) {
		ObjSound_Play(bgm);
	}
	case(EV_PAUSE_ENTER){
		ObjSound_SetVolumeRate(bgm, 40);
	}
    case(EV_PAUSE_LEAVE){
		ObjSound_SetVolumeRate(bgm, 100);
	}*/
}

@Initialize{
	Init;
	SetPlayerLife(10);
	LoadSound(PlayerShotSE);
	LoadSound(BGM);
	TStage;

	objEnemy = ObjEnemy_Create(OBJ_ENEMY);
	ObjEnemy_Regist(objEnemy);
	renderBoss(1);
	//	MagicCircle;
	ObjMove_SetPosition(objEnemy, 190, -50);
	
	InstallFont(GetCurrentScriptDirectory() ~ "./System/AndaleMono.ttf");
	InstallFont(GetCurrentScriptDirectory() ~ "./System/Russell Square Regular.ttf");
	
	SetCommonData("Main", GetOwnScriptID());
	
	SetForbidPlayerShot(true);
	SetForbidPlayerSpell(true);

	ObjSound_Load(bgm, BGM);
	ObjSound_SetSoundDivision(BGM, SOUND_BGM);
	ObjSound_SetLoopEnable(bgm, true);
	ObjSound_SetLoopTime(bgm, 26.55,158.6);
	
	ObjSound_Load(bgm2, BGM2);
	ObjSound_SetSoundDivision(BGM2, SOUND_BGM);
	ObjSound_SetLoopEnable(bgm2, true);
	ObjSound_SetLoopTime(bgm2, 0, 77777);

	ObjSound_Load(bgm3, BGM3);
	ObjSound_SetSoundDivision(BGM3, SOUND_BGM);
	ObjSound_SetLoopEnable(bgm3, true);
	ObjSound_SetLoopTime(bgm3, 0, 77777);

	ObjSound_Load(bgm4, BGM4);
	ObjSound_SetSoundDivision(BGM4, SOUND_BGM);
	ObjSound_SetLoopEnable(bgm4, true);
	ObjSound_SetLoopTime(bgm4, 0, 77777);
}

@MainLoop{
	if(GetPlayerState() == STATE_END){
		FinalizeStage;
	}
	yield;
}

task TStage{
	let pluralmid = dir ~ "./Plural1.cs";
	let pluralboss1 = dir ~ "./Plural2.cs";
	let mid = LoadScriptInThread(pluralmid);
	let boss1 = LoadScriptInThread(pluralboss1);
	
	let objText = ObjText_Create(); // Dialogue. (Part 1)
	let objImg1 = ObjPrim_Create(OBJ_SPRITE_2D); // This kind of dialogue system completely de-syncs replays, but w/e.
	let objImg2 = ObjPrim_Create(OBJ_SPRITE_2D);
	let objBox = ObjPrim_Create(OBJ_SPRITE_2D);
	DialogueBox(objBox);
	wait(30);
	character(objImg1, objImg2, 1, Murloc_Norm);
	dialogue(objText, 1, "Lo sabia!");
	character(objImg1, objImg2, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 1, "...");
	character(objImg1, objImg2, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 2, "osea que?...");
	character(objImg1, objImg2, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 2, "Al fin te diste cuenta...");
	PlaySE(Twinkle3);
	ObjMove_SetDestAtWeight(objEnemy, 190, 200, 15,6);
	character(objImg1, objImg2, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 1, "Si... Aiiko esta...[r] la verdadera Aiiko...");
	SetAreaCommonData("Boss", "IsExisting", 1);
	character(objImg1, objImg2, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 2, "La verdadera Aiiko... si... [r]murio...");
	character(objImg1, objImg2, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 1, "Aii...ko...[r]Osea que tu!");
	character(objImg1, objImg2, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 2, "La Aiiko que encontraron en el bunker ese [r]30 de Abril no era un cuerpo falso... era ella...");
	character(objImg1, objImg2, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 2, "Ellos me crearon para ser su reemplazo e [r] infundir esperanza en el pueblo.");
	character(objImg1, objImg2, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 1, "Pero los Aliados encontraron a la Aiiko original...");
	character(objImg1, objImg2, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 2, "Si... eso marco un fin a nuestros planes. [r]Mi objetivo acabo antes de empezar.");
	character(objImg1, objImg2, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 1, "Pero aun seguiste con ese objetivo de todos modos.");
	character(objImg1, objImg2, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 2, "No... Encontre un objetivo mejor y mas grande!");
	character(objImg1, objImg2, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 2, "De que sirve el dominio mundial si tengo que [r]compartirlo con un partido de ineptos?");
	character(objImg1, objImg2, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 2, "Ahora que soy una idol virtual, [r]podre formar mi ejercito de simps.");
	character(objImg1, objImg2, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 2, "Ahora somos cientos! [r] PERO MANANA SEREMOS MILES");
	character(objImg1, objImg2, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 2, "Gorbenare este mundo, no como un dictador![r] sino como una diosa eterna!");
	character(objImg1, objImg2, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	//NotifyEvent(MyStageID,EV_USER_STAGE+3,NULL);
	PlaySE(PlayerShotSE);
	ObjSound_Play(bgm);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 1, "Aiiko falsa. Usted es malefica!");
	character(objImg1, objImg2, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 1, "(hmmm... Aiiko se esta tomando eeste juego mas en serio que de costumbre)");
	character(objImg1, objImg2, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 1, "(Tengo miedo)");
	character(objImg1, objImg2, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 2, "(Hehehe se que a Murloc le sorprenderan [r]mis nuevos patrones)");
	character(objImg1, objImg2, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	PlaySE(Twinkle3);
	ObjMove_SetDestAtWeight(objEnemy, 190, 160, 15,6);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText, 1, "(Kyaaa! esa sonriza de Aiiko ahora es muy tierna [r]PERO SUMAMENTE ATERRADORA!)");
	character(objImg1, objImg2, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	
	SetForbidPlayerShot(false);
	SetForbidPlayerSpell(false);
	PlaySE(PlayerShotSE);
	Obj_Delete(objText); // You HAVE to delete these manually.
	Obj_Delete(objImg1);
	Obj_Delete(objImg2);
	Obj_Delete(objBox);
	
	wait(30);
	StartScript(mid);
	Obj_Delete(objEnemy);
	
	while(!IsCloseScript(mid)){yield;}

	SetForbidPlayerShot(true);
	SetForbidPlayerSpell(true);

	let objText_ = ObjText_Create(); // Dialogue. (Part 2)
	let objImg1_ = ObjPrim_Create(OBJ_SPRITE_2D); // You also have to set up new variables for the second set.
	let objImg2_ = ObjPrim_Create(OBJ_SPRITE_2D);
	let objBox_ = ObjPrim_Create(OBJ_SPRITE_2D);
	DialogueBox(objBox_);
	
	objEnemy = ObjEnemy_Create(OBJ_ENEMY);
	ObjEnemy_Regist(objEnemy);
	renderBoss(1);
	//MagicCircle;
	ObjMove_SetPosition(objEnemy,GetClipMaxX/2,GetClipMaxY/2);
	Toki = DrawAiiko(GetClipMaxX/2,GetClipMaxY/4,false);
	wait(60);
	dialogue(objText_, 1, "Toki, que carajos haces aqui!?");
	character(objImg1_, objImg2_, 1, Murloc_Norm);
	wait(1);
	character(objImg1_, objImg2_, 2, Toki_Norm);
	character(objImg1_, objImg2_, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 3, "No te preocupes Aiiko yo te voy a ayu...dar...[r]oh...");
	character(objImg1_, objImg2_, 2, Toki_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 2, "Em... No estamos peleando. [r]Es solo juego jajaja");
	character(objImg1_, objImg2_, 1, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	PlaySE(Twinkle3);
	ObjMove_SetDestAtWeight(objEnemy, 100, GetClipMaxY/4, 15,6);
	ObjMove_SetDestAtWeight(Toki, 300, GetClipMaxY/4, 15,6);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 1, "(''Es solo un juego'' dice...) [r] (El terror que senti era muy real...)");
	character(objImg1_, objImg2_, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 3, "Oh... Parecia una pelea de verdad.");
	character(objImg1_, objImg2_, 2, Toki_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 1, "Mas que defender a Aiiko, parece que [r]solo querias dispararme con todas tus fuezas");
	character(objImg1_, objImg2_, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	StopSound(BGM);	Obj_Delete(bgm);
	dialogue(objText_, 3, "Oye! Aun tienes que pagar por lo de la otra vez!");
	character(objImg1_, objImg2_, 2, Toki_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 1, "Oh, por el amor de Dios!");
	character(objImg1_, objImg2_, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 3, "Oye, Aiiko :) [r] Me ayudas a darle su merecido a Murloc?");
	character(objImg1_, objImg2_, 2, Toki_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	PlaySE(Twinkle3);
	ObjMove_SetDestAtWeight(Toki, 130, 130, 15,6);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 2, "Bueno pues...");
	character(objImg1_, objImg2_, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	ObjSound_Play(bgm2);
	dialogue(objText_, 2, "Seria divertido un 2vs1 tehee <3");
	character(objImg1_, objImg2_, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 1, "AIIKO NOOOOOOOOOOO");
	character(objImg1_, objImg2_, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 1, "B-b-b-ueno, en ese caso tomare protecciones [r]extras...");
	character(objImg1_, objImg2_, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 3, "Escuchaste eso Aiiko? [r] Significa que darlo todo sin dudar!");
	character(objImg1_, objImg2_, 2, Toki_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 2, "Sugoi desu ne~");
	character(objImg1_, objImg2_, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 1, "NOOOOOOOOOOOoooooooooooooo");
	character(objImg1_, objImg2_, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_, 3, "Kihihi vamos Aiiko!");
	character(objImg1_, objImg2_, 2, Toki_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	PlaySE(Twinkle3);
	ObjMove_SetDestAtWeight(Toki, 100, -GetClipMaxY/4, 15,6);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	
	SetForbidPlayerShot(false);
	SetForbidPlayerSpell(false);
	PlaySE(PlayerShotSE);
	Obj_Delete(objText_);
	Obj_Delete(objImg1_);
	Obj_Delete(objImg2_);
	Obj_Delete(objBox_);

	wait(120);
	
	Obj_Delete(objEnemy);
	StartScript(boss1);

	while(!IsCloseScript(boss1)){yield;}

	let objText_B = ObjText_Create(); // Dialogue. (Part 2)
	let objImg1_B = ObjPrim_Create(OBJ_SPRITE_2D); // You also have to set up new variables for the second set.
	let objImg2_B = ObjPrim_Create(OBJ_SPRITE_2D);
	let objBox_B = ObjPrim_Create(OBJ_SPRITE_2D);
	DialogueBox(objBox_B);
	objEnemy = ObjEnemy_Create(OBJ_ENEMY);
	ObjEnemy_Regist(objEnemy);
	renderBoss(1);

	WhenTheEndComes;
	SetForbidPlayerShot(true);
	SetForbidPlayerSpell(true);

	wait(60);
	character(objImg1_B, objImg2_B, 1, Murloc_Norm);
	dialogue(objText_B, 1, "Ya basta!");
	character(objImg1_B, objImg2_B, 2, Toki_Norm);
	character(objImg1_B, objImg2_B, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "No hay nada que odie mas que rompan [r]las reglas del danmaku.");
	character(objImg1_B, objImg2_B, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 3, "Hey, vamos Murloc. Solo estabamos jugando.");
	character(objImg1_B, objImg2_B, 2, Toki_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "Jugando pero sucio!");
	character(objImg1_B, objImg2_B, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 2, "Vamos Murloc. [r]Sabiamos que ibas a poder esquivar todo eso jejeje");
	character(objImg1_B, objImg2_B, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	PlaySE(Twinkle3);
	ObjMove_SetDestAtWeight(objEnemy, GetClipMaxX/2+50,GetClipMaxY-GetClipMaxY/3, 15,6);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "Ay si, como no...");
	character(objImg1_B, objImg2_B, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 3, "Oye Murloc...");
	character(objImg1_B, objImg2_B, 2, Toki_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 3, "Por que usas tantos arcoiris en tus escudos?");
	character(objImg1_B, objImg2_B, 2, Toki_Gay);
	PlaySE(PlayerShotSE);
	wait(5);
	PlaySE(Twinkle3);
	ObjMove_SetDestAtWeight(Toki, GetClipMaxX/2-50,GetClipMaxY-GetClipMaxY/3, 15,6);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "Q-q-q-que?");
	character(objImg1_B, objImg2_B, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 2, "Oye si, me estaba preguntando lo mismo");
	character(objImg1_B, objImg2_B, 2, Aiiko_Gay);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "eh... emmm... El arcoiris es el simbolo del pacto [r]entre Dios y el hombre.");
	character(objImg1_B, objImg2_B, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "Asi que sirve mucho en encantamientos de [r]proteccion. No es lo que sus corrompidas[r]mentes piensan!");
	character(objImg1_B, objImg2_B, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "A-a-ademas! [r]Ustedes tambien usaban muchos arcoiris!");
	character(objImg1_B, objImg2_B, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 2, "Esas son las luces RGB de mi nuevo set de danmaku.");
	character(objImg1_B, objImg2_B, 2, Aiiko_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 3, "Yo solo me estaba burlando de ti.");
	character(objImg1_B, objImg2_B, 2, Toki_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "UUUYYYYYYY SE ACABO.");
	character(objImg1_B, objImg2_B, 1, Murloc_Norm);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "");
	character(objImg1_B, objImg2_B, 1, Nothing);
	character(objImg1_B, objImg2_B, 2, Nothing);
	end=true;
	PlaySE(PlayerShotSE);
	wait(600);
	dialogue(objText_B, 1, "Cuando aprenderas Toki!?");
	character(objImg1_B, objImg2_B, 1, Nothing);
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "Y TU AIIKO! Como te dejaste corromper [r]por ese demonio de cola naranja?.");
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 2, "M-M-Murloc! Por favor!.");
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 3, "N-n-no hagas nada de lo que te puedas lamentar!!");
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "Los unicos lamentos aqui seran los de ustedes!");
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "Se burlan de mi danmaku... [r]de mis hechisos...[r] y de mi!!!");
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "Unas ultimas palabras!?");
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 3, "F-f-f-Fe-Fu-fu-Feliz cumpleanos?");
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "Mi cumpleanos fue hace unas semanas [r]y nisiquiera me saludaron!");
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 2, "P-Pero nunca es tarde para celebrarlo, no!?");
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 3, "E-e-eso! Te regalaremos dos regalos cada uno [r]como disculpa!");
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "Acaso creen que compraran mi perdon [r]solo con regalos y una fiesta!");
	PlaySE(PlayerShotSE);
		thinking = true;
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 3, "S-si?");
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	dialogue(objText_B, 1, "Pues cuanta razon tienen <3");
	PlaySE(PlayerShotSE);
	wait(5);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;
	HappyEnding;
	dialogue(objText_B, 2, "Happy Ending...");
	wait(300);
	Obj_Delete(objText_B);
	Obj_Delete(objImg1_B);
	Obj_Delete(objImg2_B);
	Obj_Delete(objBox_B);
	while (GetVirtualKeyState(VK_SHOT) != KEY_PUSH && Timer<180 ) {yield; Timer++;} Timer=0;

	// STGClearScore(1000000000);

	FinalizeStage;
}

	task WhenTheEndComes{
		ObjMove_SetPosition(objEnemy,GetClipMaxX/2,GetClipMaxY/2);
		Toki = DrawAiiko(GetClipMaxX/2,-100,false);
		ObjEnemy_SetDamageRate(objEnemy, 0, 0);

		movement;
	}
	
	task movement{
		let B = 0;
		let B2= 100;
		let C = 150;
		let C2= 200;
		let X = 0;
		let Y = 0;
			X = 0;   Y = -100;
			B = 0;   B2= 100;
			C = 150; C2= 150;
			X=GetClipMaxX/2+C*sin(B2);
			Y=GetClipMaxY/2-C2*cos(B);
			PlaySE(Twinkle3);
			ObjMove_SetDestAtWeight(objEnemy,GetClipMaxX-X,Y,15,6);
			ObjMove_SetDestAtWeight(Toki,X,Y,15,6);
			while(!end){
			ObjMove_SetPosition(GetPlayerObjectID,GetClipMaxX/2,GetClipMaxY-GetClipMaxY/4);
			SetPlayerSpeed(0,0);
			yield;
			}
			ObjMove_SetPosition(GetPlayerObjectID,GetClipMaxX/2,GetClipMaxY+100);
			PlaySE(Twinkle3);
			ObjMove_SetDestAtWeight(objEnemy,GetClipMaxX-X,Y,15,6);
			ObjMove_SetDestAtWeight(Toki,X,Y,15,6);
		YaValieronVergas;
	}
	
	task YaValieronVergas{

		let path1 = CSD ~ "./System/Img/Malkuth_Faceless.png";
		let obj1 = ObjPrim_Create(OBJ_SPRITE_2D);
		//ObjRender_SetBlendType(obj1, BLEND_MULTIPLY);
		Obj_SetRenderPriority(obj1, 0.31);
		ObjPrim_SetTexture(obj1, path1);
		ObjSprite2D_SetSourceRect(obj1, 1, 1, 420, 345);
		ObjSprite2D_SetDestRect(obj1,0,100,GetStgFrameWidth, GetStgFrameHeight+100);
		ObjRender_SetScaleXYZ(obj1,3.5,3.5,0);

		let alpha = 0;
		TShake(20,255,24);
		loop(255){
			ObjRender_SetAlpha(obj1, alpha);
			Obj_SetVisible(obj1, alpha > 0);
			ObjSprite2D_SetDestRect(obj1,-135,200-alpha,GetStgFrameWidth-135, GetStgFrameHeight+200-alpha);
			alpha++;
			yield;
		}
		path1 = CSD ~ "./System/Img/Malkuth_Eyes.png";
		ObjPrim_SetTexture(obj1, path1);

		let path2 = CSD ~ "./System/Img/Malkuth_Dots.png";
		let obj2 = ObjPrim_Create(OBJ_SPRITE_2D);
		//ObjRender_SetBlendType(obj1, BLEND_MULTIPLY);
		Obj_SetRenderPriority(obj2, 0.31);
		ObjPrim_SetTexture(obj2, path2);
		ObjSprite2D_SetSourceRect(obj2, 1, 1, 420, 345);
		ObjSprite2D_SetDestRect(obj2,-135,200-alpha,GetStgFrameWidth-135, GetStgFrameHeight+200-alpha);
		ObjRender_SetScaleXYZ(obj2,3.5,3.5,0);
		wait(30);
		let Y = 0;
		loop(8){
			ObjSprite2D_SetDestRect(obj2,-135,200-alpha-Y,GetStgFrameWidth-135, GetStgFrameHeight+200-alpha-Y);
			Y+=0.5;
			wait(6);
		}
		
		hands;
		let X = 0;
		loop{
			ObjSprite2D_SetDestRect(obj2,-135+X,200-alpha-Y,GetStgFrameWidth-135+X, GetStgFrameHeight+200-alpha-Y);
			X=rand(-2,2);
			wait(2);
			if(holding){break;}
		}
			ObjSprite2D_SetDestRect(obj1,-135,120-alpha,GetStgFrameWidth-135, GetStgFrameHeight+120-alpha);
			ObjMove_SetPosition(objEnemy,GetClipMaxX/4,GetClipMaxY-GetClipMaxY/4);
			ObjMove_SetPosition(Toki,GetClipMaxX-GetClipMaxX/4,GetClipMaxY-GetClipMaxY/4);
			InHand = true;
			ObjSound_Play(bgm3);

		loop{
		ObjSprite2D_SetDestRect(obj2,-135+X,120-alpha+4,GetStgFrameWidth-135+X, GetStgFrameHeight+120-alpha+4);
			X=rand(-2,2);
			wait(2);
			if(thinking){break;}
		}
		Obj_Delete(bgm3);
		StopSound(BGM3);
		loop(8){
			ObjSprite2D_SetDestRect(obj2,-135+X,120-alpha+Y,GetStgFrameWidth-135+X, GetStgFrameHeight+120-alpha+Y);
			Y-=0.5;
			X=0;
			wait(6);
		}

	}

	task hands{
		
		let path1 = CSD ~ "./System/Img/EnemyMarker.png";
		let obj1 = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj1, BLEND_ALPHA);
		Obj_SetRenderPriority(obj1, 0.30);
		ObjPrim_SetTexture(obj1, path1);
		ObjSprite2D_SetSourceRect(obj1, 0, 0, GetStgFrameWidth, GetStgFrameHeight);
		ObjSprite2D_SetDestRect(obj1,0,0,GetStgFrameWidth, GetStgFrameHeight);
		
		let path2 = CSD ~ "./System/Img/Hands.png";
		let HANDS=ObjEnemy_Create(OBJ_ENEMY);
		Obj_SetRenderPriority(obj1, 0.30);
		ObjEnemy_Regist(HANDS);
		ObjPrim_SetTexture(HANDS, path2);
		ObjSprite2D_SetSourceRect(HANDS, 0, 0, 960, 569);
		ObjSprite2D_SetDestCenter(HANDS);
		ObjRender_SetScaleXYZ(HANDS,0.1,0.1,0);

		let path3 = CSD ~ "./System/Img/Static.jpeg";
		let Static = ObjPrim_Create(OBJ_SPRITE_2D);
		Obj_SetRenderPriority(Static, 0.40);
		ObjPrim_SetTexture(Static, path3);
		ObjSprite2D_SetSourceRect(Static, 0, 0, GetStgFrameWidth, GetStgFrameHeight);
		ObjSprite2D_SetDestRect(Static,0,0,GetStgFrameWidth, GetStgFrameHeight);
			ObjRender_SetAlpha(Static, 0);

		let alpha = 0;
		let X = 0;
		let Y = 0;
		Obj_Delete(bgm2);
		StopSound(BGM2);
		PlaySE(Caution);
		loop(120){
			ObjRender_SetAlpha(obj1, alpha);
			Obj_SetVisible(obj1, alpha > 0);
			ObjSprite2D_SetSourceRect(obj1,X,X/2,GetStgFrameWidth/2+X, GetStgFrameHeight/2+X/2);
			if(alpha<255){alpha++;}
			X+=5;

			ObjMove_SetPosition(HANDS,GetClipMaxX/2,GetClipMaxY+100-Y*30);
			ObjRender_SetScaleXYZ(HANDS,0.1+Y/30,0.1+Y/30,1);
			ObjRender_SetAlpha(HANDS, alpha*2);
			Obj_SetVisible(HANDS, alpha > 0);
			Y+=0.1;
			yield;
		}

		PlaySE(TV);
		loop(60){
			ObjRender_SetAlpha(Static, 255);
			ObjSprite2D_SetSourceRect(Static,X,Y,GetClipMaxX+X, GetClipMaxY+Y);
			X=rand(-200,200);
			Y=rand(-200,200);
			yield;
		}
		holding =true;
		Obj_Delete(HANDS);
		Obj_SetRenderPriority(Static, 0.29);
		loop{
			ObjRender_SetAlpha(Static, 255);
			ObjSprite2D_SetSourceRect(Static,X,Y,GetClipMaxX+X, GetClipMaxY+Y);
			ObjSprite2D_SetSourceRect(obj1,alpha,alpha/2,GetStgFrameWidth/2+alpha, GetStgFrameHeight/2+alpha/2);
			X=rand(-200,200);
			Y=rand(-200,200);
			alpha+=5;
			yield;
		}

	}

	task HappyEnding{
		PlaySound(Celebration);
			ObjSound_Play(bgm4);
		let A=0;
		let path1 = CSD ~ "./System/Img/HB.png";
		let obj1 = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj1, BLEND_ALPHA);
		Obj_SetRenderPriority(obj1, 0.40);
		ObjPrim_SetTexture(obj1, path1);
		ObjSprite2D_SetSourceRect(obj1, 0, 0, 294, 420);
		ObjSprite2D_SetDestRect(obj1,0,0,GetStgFrameWidth, GetStgFrameHeight);
			ObjRender_SetColor(obj1, A, A, A);

		loop(120){
			ObjRender_SetColor(obj1, A, A, A);
			A+=255/120;
			yield;
		}
	}

task FinalizeStage{
	wait(180);
	StopSound(BGM);
	if(GetScore > GetAreaCommonData("HighScore", "Score", 0)){ // Saves the high score.
		SetAreaCommonData("HighScore", "Score", GetScore);
		SaveCommonDataAreaA1("HighScore");
	}
	CloseStgScene();
}