#TouhouDanmakufu[Single]
	#ScriptVersion[3]
	#Title["Aiiko_NS5"]
	#Text["Aiiko sacudiendo la espada a todo gas"]
	#Player["./System/Murloc/Reimu/Reimu.txt"]
	#include"./Index.txt"

	let objEnemy;
		let ex = 0;
		let ey = 0;
	
	@Initialize{
		SetAutoDeleteObject(true);
		objEnemy = ObjEnemy_Create(OBJ_ENEMY_BOSS);
		ObjEnemy_Regist(objEnemy);
		ObjMove_SetDestAtFrame(objEnemy,GetClipMaxX/2,GetClipMaxY/4,30);
		movement;
		renderBoss(1);
		TEnd;

		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets upon appearance	
	}

	@MainLoop{
		ex = ObjMove_GetX(objEnemy);
		ey = ObjMove_GetY(objEnemy);
		ObjEnemy_SetIntersectionCircleToShot(objEnemy, ex, ey, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(objEnemy, ex, ey, 24);

		yield;
	}

	@Event{
		alternative(GetEventType())
		case(EV_REQUEST_LIFE)
		{
			SetScriptResult(4500);
		}
		case(EV_REQUEST_TIMER)
		{
			SetScriptResult(120);
		}
	}
	
	task movement{
			wait(180);
		let X = 0;
		let Y = 0;
		Fire;
		
		loop{
		X = rand(GetPlayerX-100,GetPlayerX+100);
		Y = rand(GetClipMaxY/3,GetClipMaxY/8);
		if(X<GetClipMaxX/5){X =GetClipMaxX/5;}
		if(X>(GetClipMaxX/5)*4){X =(GetClipMaxX/5)*4;}
			ObjMove_SetDestAtWeight(objEnemy, X, Y, 15,6);
			wait(60);
			yield;
		}
	}
	
	task Fire{
		let X = ex+rand(50,-50);
		let Y = ey+rand(25,-25);;
		let angle = rand(0,360);
		let angle2 = atan2(GetPlayerY-Y,GetPlayerX-X);
		let A=0;
		loop(7){TChargeEffect(X, Y,1);}
		wait(15);
			PlaySound(Attack3);
        CreateShotA2(X, Y, 10, angle2, -0.3, 2, 276, 12);
		loop(9){
			CreateShotA2(X, Y, 7, angle2+60, -0.5, 3, 273, 12);
			CreateShotA2(X, Y, 7, angle2+60+1.618*3, -0.5, 5, 273, 12);
			angle2 += 30;
		}
		angle2 = 0;
			PlaySound(Attack5);
			loop(8){
				loop(8){
					CreateShotA2(X,Y,6.5+A,angle+angle2,-0.5,1+A,38,6);
					CreateShotA2(X,Y,5+A,angle+angle2,-0.5,1+A,84,6);
					angle2+= 1.618*3;
					A+=0.3;
				}
			A=0;
			angle -= 45;
			angle2 = 0;
			wait(1);
			yield;
			}
		Fire2;
	}
	
	task Fire2{
		let X = ex+rand(50,-50);
		let Y = ey+rand(25,-25);;
		let angle = rand(0,360);
		let angle2 = atan2(GetPlayerY-Y,GetPlayerX-X);
		let A=0;
		loop(7){TChargeEffect(X, Y,1);}
		wait(15);
			PlaySound(Attack3);
		CreateShotA2(X, Y, 10, angle2, -0.3, 2, 276, 12);
		loop(9){
			CreateShotA2(X, Y, 7, angle2+60, -0.5, 3, 273, 12);
			CreateShotA2(X, Y, 7, angle2+60-1.618*3, -0.5, 5, 273, 12);
			angle2 += 30;
		}
		angle2 = 0;
			PlaySound(Attack5);
		loop(8){
			loop(8){
				CreateShotA2(X,Y,6.5+A,angle+angle2,-0.5,1+A,39,6);
				CreateShotA2(X,Y,5+A,angle+angle2,-0.5,1+A,84,6);
				angle2-= 1.618*3;
				A+=0.3;
			}
			A=0;
			angle += 45;
			angle2 = 0;
			wait(1);
			yield;
		}
		Fire;
	}
	
	task TEnd{
		while(ObjEnemy_GetInfo(objEnemy, INFO_LIFE) > 0)
		{
			yield;
		}

		let ex = ObjMove_GetX(objEnemy);
		let ey = ObjMove_GetY(objEnemy);
		TExplosionA(ex, ey, 10, 0.6);
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets	

		//When making plural scripts,
		//Deleting the enemy allows the plural script to proceed on to the next script.
		//Do not forget to delete the enemy.
		Obj_Delete(objEnemy);

		loop(30){yield;}

		//Please close the script at the end
		CloseScript(GetOwnScriptID());
	}