#TouhouDanmakufu[Single]
	#ScriptVersion[3]
	#Title["Aiiko_S3"]
	#Text["Magical Advanced Technology [r] A spell card full of feathers... everywhere"]
	#Player["./System/Murloc/Reimu/Reimu.txt"]
	#include"./Index.txt"

	let objEnemy;
		let ex = 0;
		let ey = 0;
	
	@Initialize{
		SetAutoDeleteObject(true);
	
		let objScene = GetEnemyBossSceneObjectID();
		ObjEnemyBossScene_StartSpell(objScene);

		objEnemy = ObjEnemy_Create(OBJ_ENEMY_BOSS);
		ObjEnemy_Regist(objEnemy);
		ObjMove_SetDestAtWeight(objEnemy,190,100,8,5);
		movement;
		renderBoss(1);
		TEnd;

		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets upon appearance	
	}

	@MainLoop{
		ex = ObjMove_GetX(objEnemy);
		ey = ObjMove_GetY(objEnemy);
		ObjEnemy_SetIntersectionCircleToShot(objEnemy, ex, ey, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(objEnemy, ex, ey, 24);

		yield;
	}

	@Event{
		alternative(GetEventType())
		case(EV_REQUEST_LIFE)
		{
			SetScriptResult(3000);
		}
		case(EV_REQUEST_TIMER)
		{
			SetScriptResult(60);
		}
		case(EV_REQUEST_SPELL_SCORE) {
			SetScriptResult(200000);
		}
	}

	
	task movement{
		Cutin(objEnemy,"Magical Advanced Technology",1);
		wait(60);
		AttackOn;
		wait(60);
				PlaySound(PowerUp);
			loop(30){
				TChargeEffect(ex,ey,1);
				yield;
			}
		loop{
			wait(30);
			ObjMove_SetAngle(objEnemy,GetAngleToPlayer(objEnemy)+rand(5,-5));
			ObjMove_SetSpeed(objEnemy,rand(4,7));
			ObjMove_SetAcceleration(objEnemy,-0.1);
				PlaySound(Twinkle3);
			Fire1;
			Fire2;
			wait(rand(60,90));
			ObjMove_SetDestAtWeight(objEnemy,rand(GetClipMinX+100,GetClipMaxX-100),rand(GetClipMinY+50,GetClipMinY+150),8,5);
			Fire2;
			wait(rand(30,60));
			loop(5){TChargeEffect(ex,ey,1);}
				PlaySound(PowerUp);
		}
	}
	
	task Fire1{
		let A  = rand(0,360);
		let B  = GetAngleToPlayer(objEnemy)-90;
		let B2 = GetAngleToPlayer(objEnemy)-90;
		let C  = 0;
		let C2 = 0;
		let angle = 0;
			loop(60){
				while (angle<360){
					CreateStraightLaserA1(ex+30*sin(angle+B),ey-30*cos(angle+B),angle+B-90,100+C,10,6,69,0);
					CreateStraightLaserA1(ex+30*sin(angle+B2),ey-30*cos(angle+B2),angle+B2-90,100+C,10,6,69,0);
					angle+=360/1;
				}
				angle=0;
				B+=180/59;
				B2-=180/59;
				C+=200/60;
				wait(1);
			}
			C2 = 1;
			PlaySound(Attack2);
			loop(5){
				let obj  = CreateCurveLaserA1(ex+30*sin(angle+B2),ey-30*cos(angle+B2), C2, B-90+20, 75, 8, 69, 12);
				let obj2 = CreateCurveLaserA1(ex+30*sin(angle+B2),ey-30*cos(angle+B2), C2, B-90-20, 75, 8, 69, 12);
				let obj3 = CreateCurveLaserA1(ex+30*sin(angle+B2),ey-30*cos(angle+B2), C2, B-90+10, 75, 8, 69, 12);
				let obj4 = CreateCurveLaserA1(ex+30*sin(angle+B2),ey-30*cos(angle+B2), C2, B-90-10, 75, 8, 69, 12);
				//CreateCurveLaserA1(ex+30*sin(angle+B2),ey-30*cos(angle+B2), rand(1,5), B-90+rand(-15,15), 100, 10, 69, 12);
				ObjMove_AddPatternA2 (obj,  0, NO_CHANGE, NO_CHANGE, 0.02, -0.5, 10);
				ObjMove_AddPatternA2 (obj, 60, NO_CHANGE, NO_CHANGE, 0.02,  0.5, 10);
				ObjMove_AddPatternA2 (obj2, 0, NO_CHANGE, NO_CHANGE, 0.02,  0.5, 10);
				ObjMove_AddPatternA2 (obj2,60, NO_CHANGE, NO_CHANGE, 0.02, -0.5, 10);
				ObjMove_AddPatternA2 (obj3, 0, NO_CHANGE, NO_CHANGE, 0.02, -0.7, 10);
				ObjMove_AddPatternA2 (obj3,60, NO_CHANGE, NO_CHANGE, 0.02,  0.2, 10);
				ObjMove_AddPatternA2 (obj4, 0, NO_CHANGE, NO_CHANGE, 0.02,  0.7, 10);
				ObjMove_AddPatternA2 (obj4,60, NO_CHANGE, NO_CHANGE, 0.02, -0.2, 10);
				loop(5){TExplodeEffect(ObjMove_GetX(obj),ObjMove_GetY(obj),1);}
				C2++;
			}
			C = rand(0,360);
			C2 = 0.01;
			loop(90){
				CreateShotA2(ex+30*sin(B),ey-30*cos(B),0,angle+B+C,C2,3,84,9);
				CreateShotA2(ex+30*sin(B),ey-30*cos(B),0,angle+B+C,C2,3,220,6);
				if (A>=180){angle+=360/15+(1.618*30.6);}
				if (A< 180){angle-=360/15+(1.618*30.6);}
				C2 += 0.001;
			}
			loop(72){
				let obj =CreateShotA2(ex+30*sin(B),ey-30*cos(B),3,angle+B,-0.1,0,289,0);
				let obj2=CreateShotA2(ex+30*sin(B),ey-30*cos(B),3,angle+B,-0.1,0,289,0);
				let obj3=CreateShotA2(ex+30*sin(B),ey-30*cos(B),0,angle+B,1,3,289,0);
				if (A>=180){ObjMove_AddPatternA2 (obj,  0, 0, NO_CHANGE, 1,-3, 4);
							ObjMove_AddPatternA2 (obj2, 0, 0, NO_CHANGE, 1, 3, 5);
							ObjMove_AddPatternA2 (obj , 18, NO_CHANGE, NO_CHANGE, 1, 0, 4);
							ObjMove_AddPatternA2 (obj2,18, NO_CHANGE, NO_CHANGE, 1, 0, 5);
				}
				if (A< 180){ObjMove_AddPatternA2 (obj,  0, 0, NO_CHANGE, 1,-3, 5);
							ObjMove_AddPatternA2 (obj2, 0, 0, NO_CHANGE, 1, 3, 4);
							ObjMove_AddPatternA2 (obj, 18, NO_CHANGE, NO_CHANGE, 1, 0, 5);
							ObjMove_AddPatternA2 (obj2,18, NO_CHANGE, NO_CHANGE, 1, 0, 4);
				}
				ObjShot_SetIntersectionEnable(obj, false);
				ObjShot_SetIntersectionEnable(obj2,false);
				ObjShot_SetIntersectionEnable(obj3,false);
				deleteshot2(obj );
				deleteshot2(obj2);
				deleteshot2(obj3);
				angle-=360/72;
			}
			angle=0;
	}

	task deleteshot2(obj2){
		wait(24);
		ObjShot_FadeDelete(obj2);
	}
	
	task Fire2{
		let A = rand(-30,30);
		let B = rand(-30,30);
		let C = ObjMove_GetAngle(objEnemy)+rand(-90,90)+180;
		let C2;
		let angle= 0;
		loop(3){
			loop(7){
				//PlaySound(Attack3SFX);
				C2 = rand(1,2);
				CreateShotA2(ex+A,ey+B,0,C,0.1,C2,86,12);
				CreateShotA2(ex+A,ey+B,0,C,0.1,C2,220,6);
				A = rand(-60,60);
				B = rand(-30,30);
				C = ObjMove_GetAngle(objEnemy)+rand(-90,90)+180;
			}
			wait(12);
			angle=0;
		yield;
		}
	}
	
	task TEnd{
		while(ObjEnemy_GetInfo(objEnemy, INFO_LIFE) > 0)
		{
			yield;
		}

		let ex = ObjMove_GetX(objEnemy);
		let ey = ObjMove_GetY(objEnemy);
		TExplosionA(ex, ey, 10, 0.6);
		loop(5){TExplodeEffect(ex,ey,1);}
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets	

		//When making plural scripts,
		//Deleting the enemy allows the plural script to proceed on to the next script.
		//Do not forget to delete the enemy.
		Obj_Delete(objEnemy);

		loop(30){yield;}

		//Please close the script at the end
		CloseScript(GetOwnScriptID());
	}