#TouhouDanmakufu[Single]
	#ScriptVersion[3]
	#Title["Aiiko_S6"]
	#Text["Deus Ex Machina [r] God is here in the internet..."]
	#Player["./System/Murloc/Reimu/Reimu.txt"]
	#include"./Index.txt"

	let objEnemy;
		let ex = 0;
		let ey = 0;
		let rotate = false;
	
	@Initialize{
		SetAutoDeleteObject(true);
	
		let objScene = GetEnemyBossSceneObjectID();
		ObjEnemyBossScene_StartSpell(objScene);

		objEnemy = ObjEnemy_Create(OBJ_ENEMY_BOSS);
		ObjEnemy_Regist(objEnemy);
		ObjMove_SetPosition(objEnemy,190,160);
		ObjMove_SetDestAtWeight(objEnemy,GetClipMaxX/2,GetClipMaxY/2,8,5);
		ObjEnemy_SetDamageRate(objEnemy,0,0);
		movement;
		renderBoss(1);
		TEnd;

		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets upon appearance	
	}

	@MainLoop{
		ex = ObjMove_GetX(objEnemy);
		ey = ObjMove_GetY(objEnemy);
		ObjEnemy_SetIntersectionCircleToShot(objEnemy, ex, ey, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(objEnemy, ex, ey, 24);

		yield;
	}

	@Event{
		alternative(GetEventType())
		case(EV_REQUEST_IS_DURABLE_SPELL) {
		SetScriptResult(true);
		}
		case(EV_REQUEST_LIFE)
		{
			SetScriptResult(10);
		}
		case(EV_REQUEST_TIMER)
		{
			SetScriptResult(112);
		}
		case(EV_REQUEST_SPELL_SCORE) {
			SetScriptResult(200000);
		}
	}
	
	task movement{
		Cutin(objEnemy,"Deus Ex Machina",1);
		wait(12);
		PlaySound(PowerUp);
		loop(60){
			TChargeEffect(ex,ey,1);
			wait(1);}
		wait(40);
		
		Fire;
	}
	
	task Fire{
		wait(30);
		let B = 180;
		let B2 = 180;
		let C = 0;
		let angle= 0;

		loop(60){
			while (angle<360){
				CreateStraightLaserA1(ex+30*sin(angle+B),ey-30*cos(angle+B),angle+B-90,100+C,10,6,69,0);
				CreateStraightLaserA1(ex+30*sin(angle+B2),ey-30*cos(angle+B2),angle+B2-90,100+C,10,6,69,0);
				TExplodeEffect(ex,ey,1);
				angle+=360/1;
			}
			angle=0;
			B+=180/59;
			B2-=180/59;
			C+=200/60;
			wait(1);
		}
		wait(12);
		B = 0;
		B2 = 0;
		C = 0;

		let A = 1;
		let B3 = 60*5+30;

		loop(60){
				PlaySound(Twinkle);
			while (angle<360){
				CreateStraightLaserA1(ex+30*sin(angle+B),ey-30*cos(angle+B),angle+B-90,100+C,10,6,69,0);
				CreateStraightLaserA1(ex+30*sin(angle+B2),ey-30*cos(angle+B2),angle+B2-90,100+C,10,6,69,0);
				let obj =  CreateShotA2(ex+B3*sin(angle),ey-B3*cos(angle),0,angle-90,0,5,292,30);
				TChargeEffect(ObjMove_GetX(obj), ObjMove_GetY(obj),1);
				ObjShot_SetSpellResist(obj,true);
				ObjShot_SetAutoDelete (obj, false);
				rotation(obj,B3,A);
				trail(obj);
				//eye(obj);
				angle+=360/1;
			}
			angle=0;
			A++;
			B+=180/59;
			B2-=180/59;
			B3 -=5;
			C+=200/60;
			if(Obj_IsDeleted(objEnemy)){break;}
		yield;
		}
			wait(30);
		rotate = true;
		Fire2;
		
		B = 180;
		C = 0;
			PlaySound(PowerUp);
		loop(60){
			TChargeEffect(GetPlayerX,GetPlayerY,1);
			while (angle<360){
				CreateStraightLaserA1(ex+30*sin(angle+B),ey-30*cos(angle+B),angle+B-90,100+C,10,6,69,0);
				angle+=360/2;
			}
			angle=0;
			B+=180/59;
			C+=200/60;
			wait(1);
		}
		SetForbidPlayerShot(true);
	}

	task rotation(obj, dist, speed){
		while(!rotate){yield;}
		wait(60);
		let alpha=0;
		let angle=0;
		let angle2=0;
		let A=0;
		let obj2=CreateShotA1(ObjMove_GetX(obj)+5*sin(angle),ObjMove_GetY(obj)-5*cos(angle2),0,GetAngleToPlayer(obj),198,0);
			ObjShot_SetIntersectionEnable(obj2, false);
					ObjShot_SetAutoDelete(obj2, false);
		ObjRender_SetAlpha(obj2,0);
		loop{
			if(alpha<255){alpha+=0.5;}
			ObjRender_SetAlpha(obj2,alpha);
			angle2 = GetAngleToPlayer(obj);
			ObjMove_SetPosition(obj2,ObjMove_GetX(obj)+5*sin(angle2+90),ObjMove_GetY(obj)-5*cos(angle2+90));
			ObjMove_SetAngle(obj2,angle2+90);

			ObjMove_SetDestAtWeight(obj,ex+dist*sin(angle),ey-dist*cos(angle),15,6);
			angle+= speed/35;

			yield;
		}
	}

	task trail(obj){
		while(!rotate){yield;}
		wait(60);
		loop{
			let obj2=CreateShotA2(ObjMove_GetX(obj)+rand(-5,5),ObjMove_GetY(obj)+rand(-5,5),0,0,0,0,rand(189,191),12);
			deleteshot(obj2);
			wait(3);
			yield;
		}
	}

	task deleteshot(obj2){
		wait(rand(6,11));
		Obj_Delete(obj2);
	}

	task Fire2{
		let A = 30;
		let B = 0;
		let B2 = 0;
		let C = 36;
		let angle= 0;
		wait(60);
		loop{
			while (angle<360){
				if(Obj_IsDeleted(objEnemy)){break;}
				PlaySound(Twinkle3);
				let obj1 = CreateShotA2(ex+A*sin(angle+B),ey-A*cos(angle+B),-0.5,angle-B*12+90,0.01,2,86,18);
				let obj2 = CreateShotA2(ex+A*sin(angle+B),ey-A*cos(angle+B),-0.5,angle-B*12+90,0.01,2,84,15);
				let obj3 = CreateShotA2(ex+A*sin(angle+B),ey-A*cos(angle+B),-0.5,angle-B*12+90,0.01,2,220,10);
					ObjMove_AddPatternA2(obj1, 60, NO_CHANGE, NO_CHANGE, 0.01, 2, 3);
					ObjMove_AddPatternA2(obj2, 60, NO_CHANGE, NO_CHANGE, 0.01, 2, 3);
					ObjMove_AddPatternA2(obj3, 60, NO_CHANGE, NO_CHANGE, 0.01, 2, 3);
					ObjMove_AddPatternA2(obj1, 220, NO_CHANGE, NO_CHANGE, 0.01, 0, 2);
					ObjMove_AddPatternA2(obj2, 220, NO_CHANGE, NO_CHANGE, 0.01, 0, 2);
					ObjMove_AddPatternA2(obj3, 220, NO_CHANGE, NO_CHANGE, 0.01, 0, 2);
				let obj4 = CreateShotA2(ex-A*sin(angle+B),ey-A*cos(angle+B),-0.5,angle-B2*12+90,0.01,2,86,18);
				let obj5 = CreateShotA2(ex-A*sin(angle+B),ey-A*cos(angle+B),-0.5,angle-B2*12+90,0.01,2,84,15);
				let obj6 = CreateShotA2(ex-A*sin(angle+B),ey-A*cos(angle+B),-0.5,angle-B2*12+90,0.01,2,220,10);
					ObjMove_AddPatternA2(obj4, 60, NO_CHANGE, NO_CHANGE, 0.01, -2, 3);
					ObjMove_AddPatternA2(obj5, 60, NO_CHANGE, NO_CHANGE, 0.01, -2, 3);
					ObjMove_AddPatternA2(obj6, 60, NO_CHANGE, NO_CHANGE, 0.01, -2, 3);
					ObjMove_AddPatternA2(obj4, 220, NO_CHANGE, NO_CHANGE, 0.01, 0, 2);
					ObjMove_AddPatternA2(obj5, 220, NO_CHANGE, NO_CHANGE, 0.01, 0, 2);
					ObjMove_AddPatternA2(obj6, 220, NO_CHANGE, NO_CHANGE, 0.01, 0, 2);

				angle+=360/C;
				B+=1.618;
				wait(3);
			}
			angle=0;
		yield;
		}
	}

	task TEnd{
		while(ObjEnemy_GetInfo(objEnemy, INFO_LIFE) > 0)
		{
			yield;
		}

		let ex = ObjMove_GetX(objEnemy);
		let ey = ObjMove_GetY(objEnemy);
		TExplosionA(ex, ey, 10, 0.6);
		loop(10){TExplodeEffect(ex,ey,1);}
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets	

		//When making plural scripts,
		//Deleting the enemy allows the plural script to proceed on to the next script.
		//Do not forget to delete the enemy.
		Obj_Delete(objEnemy);

		loop(30){yield;}

		//Please close the script at the end
		CloseScript(GetOwnScriptID());
	}