#TouhouDanmakufu[Single]
	#ScriptVersion[3]
	#Title["Aiiko_NS1"]
	#Text["Aiiko sacudiendo las alas"]
	#Player["./System/Murloc/Reimu/Reimu.txt"]
	#include"./Index.txt"

	let objEnemy;
		let ex = 0;
		let ey = 0;
	
	@Initialize{
		SetAutoDeleteObject(true);
		objEnemy = ObjEnemy_Create(OBJ_ENEMY_BOSS);
		ObjEnemy_Regist(objEnemy);
		ObjMove_SetPosition(objEnemy,GetClipMaxX/2,160);
		ObjMove_SetDestAtFrame(objEnemy,GetClipMaxX/2,GetClipMaxY/4,30);
		movement;
		renderBoss(1);
		TEnd;

		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets upon appearance	
	}

	@MainLoop{
		ex = ObjMove_GetX(objEnemy);
		ey = ObjMove_GetY(objEnemy);
		ObjEnemy_SetIntersectionCircleToShot(objEnemy, ex, ey, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(objEnemy, ex, ey, 24);

		yield;
	}

	@Event{
		alternative(GetEventType())
		case(EV_REQUEST_LIFE)
		{
			SetScriptResult(6000);
		}
		case(EV_REQUEST_TIMER)
		{
			SetScriptResult(120);
		}
	}
	
	task movement{
			wait(90);
		PlaySound(PowerUp);
			loop(30){
				TChargeEffect(ex, ey,1);
				wait(3);
			}
		let X = 0;
		let Y = 0;
		Fire;
		Fire3;
		
		loop{
		X = rand(GetPlayerX-50,GetPlayerX+50);
		Y = rand(GetClipMaxY/4,GetClipMaxY/8);
		if(X<GetClipMaxX/5){X =GetClipMaxX/5;}
		if(X>(GetClipMaxX/5)*4){X =(GetClipMaxX/5)*4;}
			ObjMove_SetDestAtWeight(objEnemy, X, Y, 15,6);
			wait(180);
			yield;
		}
	}
	
	task Fire{
		let X = ex+rand(50,-50);
		let Y = ey+rand(25,-25);;
		let angle = rand(0,360);
		let angle2 = 0;
		let A=0;
			wait(24);
			PlaySound(Attack5);
			loop(8){
				loop(8){
					CreateShotA2(X,Y,7+A,angle+angle2,-0.5,2+A,38,6);
					CreateShotA2(X,Y,5+A,angle+angle2,-0.5,2+A,83,6);
					angle2+= 1.618*2;
					A+=0.2;
				}
			A=0;
			angle -= 45;
			angle2 = 0;
			wait(1);
			yield;
			}
			angle = rand(0,360);
			angle2 = 0;
			X = ex+rand(50,-50);
			Y = ey+rand(50,-50);
		Fire2;
	}
	
	task Fire2{
		let X = ex+rand(50,-50);
		let Y = ey+rand(25,-25);;
		let angle = rand(0,360);
		let angle2 = 0;
		let A=0;
			wait(24);
			PlaySound(Attack5);
			loop(8){
				loop(8){
					CreateShotA2(X,Y,7+A,angle+angle2,-0.5,2+A,39,6);
					CreateShotA2(X,Y,5+A,angle+angle2,-0.5,2+A,84,6);
					angle2-= 1.618*2;
					A+=0.2;
				}
				A=0;
				angle += 45;
				angle2 = 0;
				wait(1);
				yield;
			}
			angle = rand(0,360);
			angle2 = 0;
			X = ex+rand(50,-50);
			Y = ey+rand(50,-50);
		Fire;
	}

	task Fire3{
		wait(90);
		loop{
			TChargeEffect(ex, ey,1);
			wait(30);
			PlaySound(Attack3);
			CreateShotA2(ex, ey, 10, GetAngleToPlayer(objEnemy), -0.5, 3, 276, 12);
			wait(90);
			yield;
		}
	}
	
	task TEnd{
		while(ObjEnemy_GetInfo(objEnemy, INFO_LIFE) > 0)
		{
			yield;
		}

		let ex = ObjMove_GetX(objEnemy);
		let ey = ObjMove_GetY(objEnemy);
		TExplosionA(ex, ey, 10, 0.6);
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets	

		//When making plural scripts,
		//Deleting the enemy allows the plural script to proceed on to the next script.
		//Do not forget to delete the enemy.
		Obj_Delete(objEnemy);

		loop(30){yield;}

		//Please close the script at the end
		CloseScript(GetOwnScriptID());
	}