#TouhouDanmakufu[Single]
	#ScriptVersion[3]
	#Title["Aiiko_NS4"]
	#Text["Aiiko sacudiendo las alas"]
	#Player["./System/Murloc/Reimu/Reimu.txt"]
	#include"./Index.txt"

	let objEnemy;
		let ex = 0;
		let ey = 0;
	
	@Initialize{
		SetAutoDeleteObject(true);
		objEnemy = ObjEnemy_Create(OBJ_ENEMY_BOSS);
		ObjEnemy_Regist(objEnemy);
		ObjMove_SetDestAtFrame(objEnemy,GetClipMaxX/2,GetClipMaxY/4,30);
		movement;
		renderBoss(1);
		TEnd;

		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets upon appearance	
	}

	@MainLoop{
		ex = ObjMove_GetX(objEnemy);
		ey = ObjMove_GetY(objEnemy);
		ObjEnemy_SetIntersectionCircleToShot(objEnemy, ex, ey, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(objEnemy, ex, ey, 24);

		yield;
	}

	@Event{
		alternative(GetEventType())
		case(EV_REQUEST_LIFE)
		{
			SetScriptResult(6000);
		}
		case(EV_REQUEST_TIMER)
		{
			SetScriptResult(120);
		}
	}
	
	task movement{
			wait(180);
		let X = 0;
		let Y = 0;
		FirePattern;
		
		loop{
		X = rand(GetPlayerX-100,GetPlayerX+100);
		Y = rand(GetClipMaxY/4,GetClipMaxY/8);
		if(X<GetClipMaxX/8){X =GetClipMaxX/8;}
		if(X>(GetClipMaxX/8)*7){X =(GetClipMaxX/8)*7;}
			ObjMove_SetDestAtWeight(objEnemy, X, Y, 15,6);
			wait(120);
			yield;
		}
	}
	
	task Fire{
		wait(30);
		let X = ex+rand(50,-50);
		let Y = ey+rand(25,-25);;
		let angle = rand(0,360);
		let angle2 = 0;
		let A=1;
			PlaySound(Attack5);
		loop(1){
			loop(8){
				loop(8){
					let obj = CreateShotA2(X,Y,7,angle+angle2,-1,A,38,6);
					ObjMove_AddPatternA2(obj, 30, NO_CHANGE, angle+angle2, NO_CHANGE, -1, A);
					ObjMove_AddPatternA2(obj, 120-A*18, NO_CHANGE, NO_CHANGE, NO_CHANGE, 0, A);
					let obj2 = CreateShotA2(X,Y,7,angle+angle2,-1,A,84,20-A*3);
					ObjMove_AddPatternA2(obj2, 30, NO_CHANGE, angle+angle2, NO_CHANGE, -1, A);
					ObjMove_AddPatternA2(obj2, 120-A*18, NO_CHANGE, NO_CHANGE, NO_CHANGE, 0, A);
					//angle2+= 1.618;
					A+=0.3;
				}
			A=1;
			angle -= 45;
			angle2 = 0;
			}
			yield;
		}
	}
	
	task Fire2{
		wait(30);
		let X = ex+rand(50,-50);
		let Y = ey+rand(25,-25);;
		let angle = rand(0,360);
		let angle2 = 0;
		let A=1;
			PlaySound(Attack5);
		loop(1){
			loop(8){
				loop(8){
					let obj = CreateShotA2(X,Y,7,angle+angle2,-0.5,A,39,6);
					ObjMove_AddPatternA2(obj, 30, NO_CHANGE, angle+angle2, NO_CHANGE, 1, A);
					ObjMove_AddPatternA2(obj, 120-A*18, NO_CHANGE, NO_CHANGE, NO_CHANGE, 0, A);
					let obj2 = CreateShotA2(X,Y,7,angle+angle2,-0.5,A,83,20-A*3);
					ObjMove_AddPatternA2(obj2, 30, NO_CHANGE, angle+angle2, NO_CHANGE, 1, A);
					ObjMove_AddPatternA2(obj2, 120-A*18, NO_CHANGE, NO_CHANGE, NO_CHANGE, 0, A);
					//angle2-= 1.618;
					A+=0.3;
				}
				A=1;
				angle += 45;
				angle2 = 0;
				}
			wait(5);
			yield;
			}
	}

	task FirePattern{
		Fire3;
		loop{
			Fire;
			Fire2;
			wait(rand(60,90));
			yield;
		}
	}

	task Fire3{
		wait(90);
		let angle = 30;
		loop{
			loop(rand(0,2)){
				loop(3){TChargeEffect(ex, ey,1);}
				wait(30);
			PlaySound(Attack3);
				loop(3){
					CreateShotA2(ex, ey, angle/5, GetAngleToPlayer(objEnemy), -1, 1+angle/10, 276, angle/5);
					CreateShotA2(ex, ey, angle/5, GetAngleToPlayer(objEnemy)-angle, -1, angle/10, 273,  angle/5);
					CreateShotA2(ex, ey, angle/5, GetAngleToPlayer(objEnemy)+angle, -1, angle/10, 273,  angle/5);
					angle+= 10;
				}
				angle = 30;
			}
			wait(rand(90,210));
		}
	}
	
	task TEnd{
		while(ObjEnemy_GetInfo(objEnemy, INFO_LIFE) > 0)
		{
			yield;
		}

		let ex = ObjMove_GetX(objEnemy);
		let ey = ObjMove_GetY(objEnemy);
		TExplosionA(ex, ey, 10, 0.6);
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets	

		//When making plural scripts,
		//Deleting the enemy allows the plural script to proceed on to the next script.
		//Do not forget to delete the enemy.
		Obj_Delete(objEnemy);

		loop(30){yield;}

		//Please close the script at the end
		CloseScript(GetOwnScriptID());
	}